<ion-content>
    <ion-toolbar>
        <ion-buttons slot="start">
            <ion-menu-button></ion-menu-button>
        </ion-buttons>
        <ion-item>
            <ion-label>{{ 'Home' | translate}} >> {{ 'Visitor Logs' | translate }}</ion-label>
        </ion-item>
    </ion-toolbar>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>

    <div *ngIf="!this.cache?.isLoading && this.loginService.userCache?.objects[0]?.subscriptionPlan!=undefined">

        <ion-grid style="width: 100%;" fixed *ngIf="!this.securityCache?.isLoading" class="ion-no-padding">
            <ion-row>
                <ion-col *ngFor="let security of this.securityCache?.objects" class="ion-no-padding" size="220px">

                    <ion-card class="ion-no-padding" *ngIf="security?.currentSecurityGuardLog!=null">
                        <ion-item class="ion-no-margin">
                            <ion-avatar slot="start" class="ion-no-margin">
                                <img
                                    [src]="security?.currentSecurityGuardLog?.securityGuard?.profilePicture?.content" />
                            </ion-avatar>
                            <ion-grid>
                                <ion-row>
                                    <ion-label style="font-size: smaller;">{{security?.name}}</ion-label><br>
                                </ion-row>
                                <ion-row>
                                    <ion-label>{{security?.currentSecurityGuardLog?.securityGuard?.name}}
                                    </ion-label>
                                </ion-row>
                            </ion-grid>
                            <ion-icon name="radio-button-on-outline" color="success"></ion-icon>
                            <ion-icon *ngIf="security?.currentSecurityGuardLog?.securityGuard?.phoneNumber != null"
                                name="call" color="primary"
                                (click)=callSecurity(security?.currentSecurityGuardLog?.securityGuard?.phoneNumber)>
                            </ion-icon>
                        </ion-item>
                    </ion-card>

                    <ion-card class="ion-no-padding" *ngIf="security?.currentSecurityGuardLog==null">
                        <ion-item class="ion-no-margin">
                            <ion-avatar slot="start" class="ion-no-margin">
                                <img [src]="security?.profilePicture?.content" />
                            </ion-avatar>
                            <ion-grid>
                                <ion-row>
                                    <ion-label style="font-size: smaller;">{{security?.name}}</ion-label><br>
                                </ion-row>
                                <ion-row>
                                    <ion-label></ion-label>
                                </ion-row>
                            </ion-grid>
                            <ion-icon name="radio-button-on-outline" color="danger"></ion-icon>
                        </ion-item>
                    </ion-card>

                </ion-col>
            </ion-row>
        </ion-grid>

        <ion-grid style="width: 100%;" fixed *ngIf="this.securityCache?.isLoading" class="ion-no-padding">
            <ion-row>
                <ion-col *ngFor="let security of ['','']" class="ion-no-padding" style="width: 220px;">
                    <ion-card class="ion-no-padding">
                        <ion-item class="ion-no-margin">
                            <ion-thumbnail slot="start" style="width: 40px;height: 40px;">
                                <ion-skeleton-text></ion-skeleton-text>
                            </ion-thumbnail>
                            <ion-grid>
                                <ion-row>
                                    <ion-skeleton-text animated></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-skeleton-text animated></ion-skeleton-text>
                                </ion-row>
                            </ion-grid>
                        </ion-item>
                    </ion-card>
                </ion-col>
            </ion-row>
        </ion-grid>

        <div *ngIf="!this.cache?.isLoading">
            <ion-list *ngFor="let visitorLog of this.cache?.objects">
                <!-- <ion-card [routerLink]="['/resident/home/logs/visitor-log',visitorLog.id]"  [ngStyle]="{'background-color': visitorLog.unRead==true? 'lightgray' : 'white'}" > -->
                <ion-card [routerLink]="['/resident/home/logs/visitor-log',visitorLog.id]">
                    <ion-card-header>
                        <ion-item>
                            <ion-avatar slot="start">
                                <img [src]="visitorLog.visitor.profilePicture.content" />
                            </ion-avatar>
                            <ion-label>{{visitorLog?.visitor?.name}}</ion-label>
                            <ion-icon end *ngIf="visitorLog.unRead" name="mail-unread"></ion-icon>
                        </ion-item>
                    </ion-card-header>
                    <ion-card-content>
                        <ion-grid>
                            <ion-row>
                                <ion-label
                                    *ngIf="isExpired(visitorLog.timeIn) && isPending(visitorLog.approvalStatus) && visitorLog.isBookedInAdvance; else elseBlock"
                                    style="color: red;">
                                    <ion-icon name="time"></ion-icon>
                                    {{getLocalTime(visitorLog.timeIn) | date:'medium'}}
                                </ion-label>
                                <ng-template #elseBlock>
                                    <ion-row>
                                        <ion-label>
                                            <ion-icon name="time"></ion-icon>
                                            {{getLocalTime(visitorLog.timeIn) | date:'medium'}}
                                        </ion-label>
                                    </ion-row>
                                </ng-template>
                            </ion-row>
                            <ion-row>
                                <ion-label>
                                    <ion-icon name="exit"></ion-icon>
                                    {{getLocalTime(visitorLog.timeOut) | date:'medium'}}
                                </ion-label>
                            </ion-row>
                            <ion-row>
                                <ion-chip color="success" *ngIf="visitorLog.isBookedInAdvance">
                                    <ion-icon name="checkmark"></ion-icon>
                                    <ion-label>{{ 'Booked' | translate }}</ion-label>
                                </ion-chip>
                                <ion-chip color="success" *ngIf="visitorLog.approvalStatus === 'Approved'">
                                    <ion-icon name="checkmark"></ion-icon>
                                    <ion-label>{{ 'Approved' | translate }}</ion-label>
                                </ion-chip>
                                <ion-chip color="danger" *ngIf="visitorLog.approvalStatus === 'Rejected'">
                                    <ion-icon name="close"></ion-icon>
                                    <ion-label>{{ 'Rejected' | translate }}</ion-label>
                                </ion-chip>
                                <ion-chip color="warning" *ngIf="visitorLog.approvalStatus === 'Hold'">
                                    <ion-icon name="hand"></ion-icon>
                                    <ion-label>{{ 'Hold' | translate }}</ion-label>
                                </ion-chip>
                                <ion-chip color="primary" *ngIf="visitorLog.approvalStatus === 'Pending'">
                                    <ion-icon name="stopwatch"></ion-icon>
                                    <ion-label>{{ 'Pending' | translate }}</ion-label>
                                </ion-chip>
                                <ion-chip color="danger"
                                    *ngIf="isExpired(visitorLog.timeIn) && isPending(visitorLog.approvalStatus) && visitorLog.isBookedInAdvance">
                                    <ion-icon name="time"></ion-icon>
                                    <ion-label>{{ 'Expired' | translate }}</ion-label>
                                </ion-chip>
                            </ion-row>
                        </ion-grid>
                    </ion-card-content>
                </ion-card>
            </ion-list>
            <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
                <ion-item>
                    <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
                </ion-item>
            </ion-card>
        </div>
        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content>
                <ion-list *ngIf="this.cache?.isNextPageLoading">
                    <ion-card *ngFor="let a of ['','','']">
                        <ion-item>
                            <ion-thumbnail slot="start">
                                <ion-skeleton-text></ion-skeleton-text>
                            </ion-thumbnail>
                            <ion-skeleton-text animated></ion-skeleton-text>
                        </ion-item>
                        <div>
                            <ion-grid>
                                <ion-row>
                                    <ion-icon name="time"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-icon name="exit"></ion-icon>
                                    <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                                </ion-row>
                                <ion-row>
                                    <ion-chip style="width: 110px" >
                                    </ion-chip>
                                    <ion-chip style="width: 110px" >
                                    </ion-chip>
                                </ion-row>
                            </ion-grid>
                        </div>
                    </ion-card>
                </ion-list>
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>


    <ion-grid style="width: 100%;" fixed *ngIf="this.cache?.isLoading && this.cache?.objects.length==0" class="ion-no-padding">
        <ion-row>
            <ion-col *ngFor="let security of ['','']" class="ion-no-padding" style="width: 220px;">
                <ion-card class="ion-no-padding">
                    <ion-item class="ion-no-margin">
                        <ion-thumbnail slot="start" style="width: 40px;height: 40px;">
                            <ion-skeleton-text></ion-skeleton-text>
                        </ion-thumbnail>
                        <ion-grid>
                            <ion-row>
                                <ion-skeleton-text animated></ion-skeleton-text>
                            </ion-row>
                            <ion-row>
                                <ion-skeleton-text animated></ion-skeleton-text>
                            </ion-row>
                        </ion-grid>
                    </ion-item>
                </ion-card>
            </ion-col>
        </ion-row>
    </ion-grid>
    <ion-list *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card *ngFor="let a of ['','','','','','','','']">
            <ion-item>
                <ion-thumbnail slot="start">
                    <ion-skeleton-text></ion-skeleton-text>
                </ion-thumbnail>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-item>
            <div>
                <ion-grid>
                    <ion-row>
                        <ion-icon name="time"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-icon name="exit"></ion-icon>
                        <ion-skeleton-text animated animated style="width: 60%"></ion-skeleton-text>
                    </ion-row>
                    <ion-row>
                        <ion-chip style="width: 110px" >
                        </ion-chip>
                        <ion-chip style="width: 110px" >
                        </ion-chip>
                    </ion-row>
                </ion-grid>
            </div>
        </ion-card>
    </ion-list>
</ion-content>